codeforces 954 D. Fight Against Traffic【BFS + 最短路】

D. Fight Against Traffic

time limit per test1 second
memory limit per test256 megabytes

Little town Nsk consists of n junctions connected by m bidirectional roads. Each road connects two distinct junctions and no two roads connect the same pair of junctions. It is possible to get from any junction to any other junction by these roads. The distance between two junctions is equal to the minimum possible number of roads on a path between them.

In order to improve the transportation system, the city council asks mayor to build one new road. The problem is that the mayor has just bought a wonderful new car and he really enjoys a ride from his home, located near junction s to work located near junction t. Thus, he wants to build a new road in such a way that the distance between these two junctions won’t decrease.

You are assigned a task to compute the number of pairs of junctions that are not connected by the road, such that if the new road between these two junctions is built the distance between s and t won’t decrease.

Input

The firt line of the input contains integers n, m, s and t (2 ≤ n ≤ 1000, 1 ≤ m ≤ 1000, 1 ≤ s, t ≤ n, s ≠ t) — the number of junctions and the number of roads in Nsk, as well as the indices of junctions where mayors home and work are located respectively. The i-th of the following m lines contains two integers ui and vi (1 ≤ ui, vi ≤ n, ui ≠ vi), meaning that this road connects junctions ui and vi directly. It is guaranteed that there is a path between any two junctions and no two roads connect the same pair of junctions.

Output

Print one integer — the number of pairs of junctions not connected by a direct road, such that building a road between these two junctions won’t decrease the distance between junctions s and t.

Examples

input

5 4 1 5
1 2
2 3
3 4
4 5

output

0

input

5 4 3 5
1 2
2 3
3 4
4 5

output

5

input

5 6 1 5
1 2
1 3
1 4
4 5
3 5
2 5

output

3

题意: 给你一个无向图,问你加一条边使得 s->t的最短路径不变

分析: 因为图的大小为1e3,所以我们暴力的判断每条边即可,我们先预处理出来s和t点到其他个点的最短路径,然后判的时候只需保证以下:
我们假设当前枚举增加i节点和j节点之间的边
只要满足s -> i + i -> j + j -> t >= s -> t即可 (箭头表示边)
还得满足s -> j + j -> i + i -> t >= s -> t

参考代码

#include<bits/stdc++.h>

using namespace std;

const int maxn = 1e3 + 10;

int ds[maxn],dt[maxn];
int n,m,s,t;

vector<int> E[maxn];

void bfs(int v,int *d) {
    for (int i = 0; i < maxn; i++) d[i] = 1000000000;
    queue<int> q;
    q.push(v);
    d[v] = 0;
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto &it : E[u]) {
            if(d[it] > d[u] + 1) {
                d[it] = d[u] + 1;
                q.push(it);
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    scanf("%d%d%d%d",&n, &m, &s, &t);
    for (int i = 0; i < m; i++) {
        int x,y;
        scanf("%d%d",&x, &y);
        E[x].push_back(y);
        E[y].push_back(x);
    }
    bfs(s,ds);
    bfs(t,dt);
    int res = 0;
    int dis = ds[t];
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            if(ds[i] + dt[j] + 1 >= dis && ds[j] + dt[i] + 1 >= dis) {
                res++;
            }
        }
    }
    cout<<res - m<<endl;
    return 0;
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值